(* Definition of CPS transformation *)

Require Import Coq.Lists.List.
Require Import "Variable".
Require Import SourceLang.
Require Import CpsLang.


Open Scope ctype_scope.


Fixpoint cps_term (t : sterm) : cterm :=
  ct_cabs 0
  match t with
  | st_fvar x1 =>
      ct_app (ct_fcvar 0) (ct_fsvar x1)
  | st_unit =>
      ct_app (ct_fcvar 0) ct_unit
  | st_abs x1 t1 =>
      ct_app (ct_fcvar 0) (ct_sabs x1 (cps_term t1))
  | st_app tf ta =>
      ct_app (cps_term tf) (ct_cabs 1
      (ct_app (cps_term ta) (ct_cabs 2
       (ct_app (ct_app (ct_fcvar 1) (ct_fcvar 2)) (ct_fcvar 0)))))
  end.


Fixpoint cps_type (T : stype) : ctype :=
  match T with
  | sy_unit =>
      cy_unit
  | sy_func TA TR =>
      cy_func (cps_type TA) (! ! cps_type TR)
  end.


Fixpoint cps_ctxt (C : sctxt) : cctxt :=
  match C with
  | nil =>
      nil
  | (x, T) :: C' =>
      (x, cps_type T) :: cps_ctxt C'
  end.
